;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

          #include <P16F628A.INC>
            LIST        p=16F628A     
            __CONFIG    H'3F18'             ; 
                                               
Sec           equ         20h               ;  
Sec1          equ         21h               ;  
nomer         equ         22h               ;   ascii 
scetbit       equ         23h               ;  -   spi 
perem         equ         24h               ;      spi             
priem         equ         28h               ;      UART    
temp          equ         29h               ;  
tmp_symb      equ         2Ah               ;      
sp_h          equ         2Bh               ;   -  
sp_l          equ         2Ch               ;   -  

flag          equ         78h               ; 
FSR_prer      equ         7Bh               ;   FSR   
W_TEMP        equ         7Dh               ;    W
STATUS_TEMP   equ         7Eh               ;   STATUS
FSR_temp      equ         7Fh               ;   FSR   

data_gps      equ         00A0h             ;        GPS

#DEFINE       sdata       PORTB,3           ;   -
#DEFINE       sclk        PORTB,4           ;   LCD 
#DEFINE       dat_com     PORTB,5           ;
#DEFINE       res_lcd     PORTB,0           ;
#DEFINE       cs          PORTB,6           ;
#DEFINE       led         PORTB,7           ;    "GPRMC"  GPS 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


              org         0000h             ;     0000h
              goto        Start             ;   Start
           
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  

              org         0004h             ;     0004h
       
              movwf       W_TEMP            ;   
              swapf       STATUS,W          ;
              clrf        STATUS            ;
              movwf       STATUS_TEMP       ;

              movf        FSR,W             ;    FSR,  
              movwf       FSR_temp          ;    
              movf        FSR_prer,W        ;
              movwf       FSR               ;
                
priem_usart   movf        RCREG,W           ;    UART   INDF
              movwf       INDF              ;     
              movlw       '$'               ;  "$"
              xorwf       INDF,W            ;
              btfss       STATUS,Z          ;
              goto        priem_1           ; :    priem_1
              movlw       data_gps          ; :      
              movwf       FSR               ;    GPS 
              goto        exxit             ;   exxit

priem_1       movlw       0x0D              ;    
              xorwf       INDF,W            ;    0x0D
              btfss       STATUS,Z          ;
              goto        priem_2           ; :    priem_2
              bsf         flag,0            ; :      GPS 
              goto        exxit             ;   exxit
           
priem_2       incf        FSR,F             ;  FSR:    
              movlw       0xF0              ;    
              xorwf       FSR,W             ;   FSR  
              btfss       STATUS,Z          ;  0xF0 
              goto        exxit             ; :    exxit
              movlw       data_gps          ; :     
              movwf       FSR               ;    GPS 
                                           

exxit         movf        FSR,W             ;    FSR,  
              movwf       FSR_prer          ;   
              movf        FSR_temp,W        ;
              movwf       FSR               ;            

              swapf       STATUS_TEMP,W     ;   
              movwf       STATUS            ;
              swapf       W_TEMP,F          ;
              swapf       W_TEMP,W          ;
                                            ;
              retfie                        ;    

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; 
                                             
Start         clrf        PORTA             ;  PORTA
              movlw       b'01000001'       ;     B     
              movwf       PORTB             ; 
              
              movlw       b'00000111'       ; 
              movwf       CMCON             ;

              bsf         STATUS,RP0        ; 1-     
              movlw       b'00000110'       ;  \  B      
              movwf       TRISB             ;RB1,RB2,RB7 -  ,   
 
              movlw       b'11111111'       ;  \  A   
              movwf       TRISA             ;   
             
              movlw       0x19              ;  0x19   SPBRG    
              movwf       SPBRG             ;  USART,    
                                            ;  4   9600 /

              movlw       b'00100100'       ;  USART:   
              movwf       TXSTA             ;  USART,
                                            ;   USART: 8- 
                                            ;,                             
              bcf         STATUS,RP0        ; 0-  
                                            
              movlw       b'10010000'       ;  USART:   USART
              movwf       RCSTA             ;   USART: 8- 
                                            ;,  
                     
              clrf        flag              ;    
  
              movlw       data_gps          ;    (    
              movwf       FSR_prer          ; GPS)   FSR_prer,   
                                            ;  
                          
              bsf         STATUS,RP0        ; 1-  
              bsf         PIE1,RCIE         ;    USART
              bcf         STATUS,RP0        ; 0- 
              bsf         INTCON,PEIE       ;   
              bsf         INTCON,GIE        ;              
              
              call        init_lcd          ;   
              call        clear_lcd         ;   
              call        viv_not           ;    "--- "

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
              
gps_start     bcf         flag,0            ;     GPS 
gps_a0        btfss       flag,0            ;     GPS 
              goto        gps_a0            ;  :    gps_a0

                                            ; :
              movlw       .0                ;       
              call        srav_gps          ;   "GPRMC"   
              btfss       flag,1            ;  srav_gps 
              goto        gps_a1            ; :    gps_a1
              bsf         led               ;   
              call        gps_gprmc         ; :   gps_gprmc 
              bcf         led               ;   
              goto        gps_start         ;   gps_start

gps_a1        movlw       .5                ;     
              call        srav_gps          ;   "GPVTG"   
              btfss       flag,1            ;  srav_gps
              goto        gps_a2            ; :    gps_a2
              call        gps_gpvtg         ; :   gps_gpvtg
              goto        gps_start         ;   gps_start

gps_a2        movlw       .10               ;     
              call        srav_gps          ;   "GPGGA"  
              btfss       flag,1            ;  srav_gps
              goto        gps_a3            ; :    gps_a3
              call        gps_gpgga         ; :   gps_gpgga
              goto        gps_start         ;   gps_start

gps_a3        movlw       .15               ;     
              call        srav_gps          ;   "GPGSV"  
              btfss       flag,1            ;  srav_gps
              goto        gps_start         ; :    gps_start
              call        gps_gpgsv         ; :   gps_gpgsv
              goto        gps_start         ;   gps_start

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;      
;   "GPRMC",      
;  , ,  
                                            
gps_gprmc     call        ust_cur_1         ;      Lcd 
              incf        FSR,F             ;  FSR 
              call        prov_symb         ;   ,     
              btfss       flag,2            ;
              goto        time_1            ;   :    time_1
              call        viv_not           ;  ","    :     "--- " 
              goto        status_1          ;   status_1
             
time_1        movf        INDF,W            ;
              call        viv_symb          ;  ,   
      
              incf        FSR,F             ;  FSR  
              call        prov_symb         ;  ,     ","
              btfsc       flag,2            ;
              goto        status_1           ;  ","  :    status_1
              movf        INDF,W            ;
              call        viv_symb          ;  ,  
              movlw       ':'               ;
              call        viv_symb          ; ,  ":"

              incf        FSR,F             ;  FSR
              call        prov_symb         ;  ,     ","
              btfsc       flag,2            ;
              goto        status_1           ;  ","  :    status_1
              movf        INDF,W            ;
              call        viv_symb          ;  ,  

              incf        FSR,F             ;  FSR
              call        prov_symb         ;  ,     ","
              btfsc       flag,2            ;
              goto        status_1           ;  ","  :    status_1
              movf        INDF,W            ;
              call        viv_symb          ;  ,  
              movlw       ':'               ;
              call        viv_symb          ; ,  ":"
              
              incf        FSR,F             ;  FSR
              call        prov_symb         ;  ,     ","
              btfsc       flag,2            ;
              goto        status_1           ;  ","  :    status_1
              movf        INDF,W            ;
              call        viv_symb          ;  ,  

              incf        FSR,F             ;  FSR
              call        prov_symb         ;  ,     ","
              btfsc       flag,2            ;
              goto        status_1          ;  ","  :    status_1
              movf        INDF,W            ;
              call        viv_symb          ;  ,  

time_2        incf        FSR,F             ; ,   ","  
              call        prov_symb         ;  ,     ","
              btfss       flag,2            ;
              goto        time_2            ; ","  :    time_2

status_1      call        ust_cur_st        ;      Lcd 
              incf        FSR,F             ;  FSR
              call        prov_symb         ;  ,     ","
              btfsc       flag,2            ;
              goto        kord_NS_1         ;  ","   :    kord_NS_1
              movf        INDF,W            ;
              call        viv_symb          ;                
                        
              incf        FSR,F             ;  FSR
kord_NS_1     incf        FSR,F             ;  FSR
              call        ust_cur_2         ;      Lcd 

              call        prov_symb         ;   ,      
              btfss       flag,2            ;
              goto        kord_NS_2         ;   :    kord_NS_2
              call        viv_not           ;  ","    :     "--- "
              goto        tip_NS_1          ;   tip_NS_1

kord_NS_2     movf        INDF,W            ;
              call        viv_symb          ;   (),  
              incf        FSR,F             ;  FSR
              call        prov_symb         ;  ,     ","
              btfsc       flag,2            ;
              goto        tip_NS_1          ;  ","  :    tip_NS_1
              movf        INDF,W            ;       
              call        viv_symb          ;   (),       
              movlw       ' '               ;
              call        viv_symb          ; ,  " "

kord_NS_3     incf        FSR,F             ;  FSR
              call        prov_symb         ;  ,     ","
              btfsc       flag,2 
              goto        tip_NS_1          ;  ",":    tip_NS_1
              movf        INDF,W            ;   
              call        viv_symb          ;   ()
              goto        kord_NS_3         ;   kord_NS_3
 
tip_NS_1      incf        FSR,F             ;  FSR
              call        prov_symb         ;  
              btfsc       flag,2            ;
              goto        kord_WE_1         ;  ","   :    kord_WE_1
              movf        INDF,W            ;
              call        viv_symb          ;   (, )

              incf        FSR,F             ;  FSR
kord_WE_1     incf        FSR,F             ;  FSR
              call        ust_cur_3         ;      Lcd  
              call        prov_symb         ;   ,   
              btfss       flag,2            ;
              goto        kord_WE_2         ;   :    kord_WE_2
              call        viv_not           ;  ","    :     "--- "
              return                        ;   gps_gprmc

kord_WE_2     movf        INDF,W            ;
              call        viv_symb          ;   (),  
              incf        FSR,F             ;  FSR
              call        prov_symb         ;  ,     ","
              btfsc       flag,2            ;
              goto        tip_WE_1          ;  ","  :    tip_WE_1
              movf        INDF,W            ;
              call        viv_symb          ;   (),  
              incf        FSR,F             ;  FSR
              call        prov_symb         ;  ,     ","
              btfsc       flag,2            ;
              goto        tip_WE_1          ;  ","  :    tip_WE_1
              movf        INDF,W            ;
              call        viv_symb          ;   (),    
              movlw       ' '               ;
              call        viv_symb          ; ,  " "
              
kord_WE_3     incf        FSR,F             ;  FSR
              call        prov_symb         ;  ,     ","
              btfsc       flag,2            ;
              goto        tip_WE_1          ;  ",":    tip_WE_1
              movf        INDF,W           
              call        viv_symb          ;   ()
              goto        kord_WE_3         ;   kord_WE_3
              
tip_WE_1      incf        FSR,F             ;  FSR
              call        prov_symb         ;  
              btfsc       flag,2            ;
              return                        ;  ","   :    gps_gprmc
              movf        INDF,W            ;
              call        viv_symb          ;   (, )
              return                        ;   gps_gprmc

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;   "GPVTG",        

gps_gpvtg     call        ust_cur_4         ;      Lcd 

              movlw       .6                ; 3-x 
              movwf       temp              ;
gpvtg_1       incf        FSR,F             ;  FSR 
              call        prov_symb         ;  ,     ","
              btfss       flag,2            ;
              goto        gpvtg_1           ; ","  :    gpvtg_1
              decfsz      temp,F            ;  ","  :   temp
              goto        gpvtg_1           ;    0:    gpvtg_1
              
              incf        FSR,F             ;  FSR
              call        prov_symb         ;   ,       
              btfss       flag,2            ;
              goto        gpvtg_2           ;   :    gpvtg_2
              call        viv_not           ;  ","    :     "--- "
              return                        ;;   gps_gpvtg

gpvtg_2       movf        INDF,W            ;
              call        viv_symb          ;  
              incf        FSR,F             ;  FSR
              call        prov_symb         ;  ,     ","
              btfss       flag,2            ;
              goto        gpvtg_2           ; ","  :    gpvtg_2

              incf        FSR,F             ;  FSR
              call        prov_symb         ;  
              btfsc       flag,2            ;
              return                        ;  ","   :    gps_gpvtg
              movf        INDF,W            ;
              call        viv_symb          ;   (K)
              return                        ;   gps_gpvtg

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;   "GPGGA",         -   

gps_gpgga     call        ust_cur_5         ;      Lcd 

              movlw       .6                ; 4-x 
              movwf       temp              ;
gpgga_1       incf        FSR,F             ;  FSR 
              call        prov_symb         ;  ,     ","
              btfss       flag,2            ;
              goto        gpgga_1           ; ","  :    gpgga_1
              decfsz      temp,F            ;  ","  :   temp
              goto        gpgga_1           ;    0:    gpgga_1
              
              incf        FSR,F             ;  FSR
              call        prov_symb         ;   ,  - . 
              btfsc       flag,2            ;
              goto        sput_1            ;  ","    :    sput_1
              movf        INDF,W            ;
              movwf       sp_h              ;      sp_h,  
              incf        FSR,F             ;  FSR
              call        prov_symb         ;  ,     ","
              btfsc       flag,2            ;
              goto        sput_1            ;  ",":    sput_1
              movf        INDF,W            ;
              movwf       sp_l              ;      sp_l,              
              movlw       .2                ;   W,    ,  2-  
              goto        sput_2 

sput_1        movlw       .1                ;  
sput_2        movwf       temp              ;
sput_3        incf        FSR,F             ;  FSR 
              call        prov_symb         ;  ,     ","
              btfss       flag,2            ;
              goto        sput_3            ; ","  :    sput_3
              decfsz      temp,F            ;  ","  :   temp
              goto        sput_3            ;    0:    sput_3

              incf        FSR,F             ;  FSR 
              call        prov_symb         ;   ,   
              btfss       flag,2            ;
              goto        visota_1          ;   :    visota_1
              call        viv_not           ;  ","    :     "--- "
              goto        viv_sp            ;   viv_sp

visota_1      movf        INDF,W            ;
              call        viv_symb          ; 
              incf        FSR,F             ;  FSR
              call        prov_symb         ;  ,     "," 
              btfss       flag,2            ;
              goto        visota_1          ; ","  :    visota_1

              incf        FSR,F             ;  FSR
              call        prov_symb         ;  
              btfsc       flag,2            ;
              goto        viv_sp            ;  ","   :    viv_sp
              movf        INDF,W            ;
              call        viv_symb          ;   (M)
 
viv_sp        call        ust_cur_6         ;      Lcd 
              movf        sp_h,W            ;
              call        viv_symb          ; -  ,  
              movf        sp_l,W            ;
              call        viv_symb          ; -  ,  
              movlw       '/'               ;
              call        viv_symb          ;  "/"
              return                        ;   gps_gpgga

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;   "GPGSV",      -   

gps_gpgsv     call        ust_cur_sp        ;      Lcd   
            
              movlw       .2                ; 2-x 
              movwf       temp              ;
gpgsv_1       incf        FSR,F             ; 
              call        prov_symb         ;
              btfss       flag,2            ;
              goto        gpgsv_1           ;
              decfsz      temp,F            ;
              goto        gpgsv_1           ;

              movlw       '/'               ;
              call        viv_symb          ;  "/"     
              incf        FSR,F             ;  FSR
              call        prov_symb         ;   ,  -  
              btfsc       flag,2            ;
              return                        ;  ","    :    gps_gpgsv
              movf        INDF,W            ;
              call        viv_symb          ; -  ,  
              incf        FSR,F             ;  FSR
              call        prov_symb         ;  ,     ","
              btfsc       flag,2            ;
              return                        ;  ",":    gps_gpgsv
              movf        INDF,W            ; -  ,  
              call        viv_symb          ;
              return                        ;   gps_gpgsv

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                                            ;    INDF     ","
prov_symb     bcf         flag,2            ;  
              movlw       ','               ;
              xorwf       INDF,W            ;
              btfss       STATUS,Z          ;
              return                        ; :   
              bsf         flag,2            ; :   
              return                        ;  
                  
viv_not       movlw       '-'               ;     (--- )
              call        viv_symb          ;  "-" 
              movlw       '-'               ;
              call        viv_symb          ;  "-" 
              movlw       '-'               ;
              call        viv_symb          ;  "-" 
              movlw       ' '               ;
              call        viv_symb          ;  " " 
              return                        ;  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  4-            
;    

srav_gps      movwf       nomer             ;           
              movlw       .5                ;    - 
              movwf       temp              ;
              bcf         flag,1            ;   
              movlw       data_gps          ;    (    
              movwf       FSR               ;( GPS)   FSR_prer
                       
srav_1        call        table             ;                
              xorwf       INDF,W            ;         
              btfss       STATUS,Z          ;
              return                        ; :   
              incf        FSR,F             ; ,   FSR
              incf        nomer,F           ;      
              decfsz      temp,F            ;  - 
              goto        srav_1            ;   :    srav_1
              bsf         flag,1            ;  :    
              return                        ;  
             
table         movlw       high tab          ;   ascii  
              movwf       PCLATH            ;
              movf        nomer,W           ;
              addlw       low tab           ;
              btfsc       STATUS,C          ;
              incf        PCLATH,F          ;
              movf        nomer,W           ;
              addwf       PCL,F             ;
 
tab           dt 'G', 'P', 'R', 'M', 'C';   ;    = 0
              dt 'G', 'P', 'V', 'T', 'G';   ;    = 5
              dt 'G', 'P', 'G', 'G', 'A';   ;    = 10
              dt 'G', 'P', 'G', 'S', 'V';   ;    = 15              
              

init_lcd      bcf        res_lcd           ;         
              nop
              nop
              bsf        res_lcd 
              nop
              nop 
              bcf        cs      
                         
              movlw      0x21              ;  , .,   
              call       sendispcom        ;
              movlw      0x13              ;   Bias 1:48
              call       sendispcom        ;
              movlw      0x04              ;   4
              call       sendispcom
              movlw      0xC1              ;  ( Vop) 6,42 (0B8)
              call       sendispcom
              movlw      0x20              ;  
              call       sendispcom  
              movlw      0x0C              ; -   
              call       sendispcom 
              return


ust_cur_1     movlw       0x40              ;    Y0
              call        sendispcom
              goto        ust
ust_cur_2     movlw       0x41              ;    Y1
              call        sendispcom
              goto        ust
ust_cur_3     movlw       0x42              ;    Y2
              call        sendispcom
              goto        ust
ust_cur_4     movlw       0x43              ;    Y3
              call        sendispcom
              goto        ust
ust_cur_5     movlw       0x44              ;    Y4
              call        sendispcom
              goto        ust
ust_cur_6     movlw       0x45              ;    Y5
              call        sendispcom
ust           movlw       0x80              ;    X0
              call        sendispcom
              return
              
ust_cur_sp    movlw       0x45              ;    Y5
              call        sendispcom
              movlw       0x8C              ;    X12
              call        sendispcom
              return

ust_cur_st    movlw       0xC2              ;    X66
              call        sendispcom
              return


clear_lcd     movlw      0x40              ;  
              call       sendispcom 
              movlw      0x80              
              call       sendispcom 
              movlw      .6
              movwf      Sec1
povt4         movlw      .84
              movwf      Sec
povt3         movlw      .0
              call       sendispdat
              decfsz     Sec,F             
              goto       povt3
              decfsz     Sec1,F             
              goto       povt4
              return

sendispcom    movwf      perem            ;    
              bcf        dat_com
              goto       povt1
sendispdat    movwf      perem
              bsf        dat_com
povt1         movlw      .8
              movwf      scetbit
povt2         bcf        sclk
              btfsc      perem,7
              bsf        sdata
              btfss      perem,7
              bcf        sdata
              bsf        sclk                                   
              rlf        perem,F
              decfsz     scetbit,F             
              goto       povt2
              bcf        sclk
              return

viv_symb      movwf       nomer             ;    
              movlw       .48
              subwf       nomer,W
              btfss       STATUS,C
              goto        viv_3

viv_1         movf        nomer,W
              sublw       .57
              btfsc       STATUS,C
              goto        viv_2
viv_3         call        kod_ascii
              goto        symb_lcd
              
viv_2         movlw       .48
              subwf       nomer,F
              
symb_lcd      movf        nomer,W
              addwf       nomer,F
              addwf       nomer,F
              addwf       nomer,F
              addwf       nomer,F
              movlw       .5
              movwf       temp
              decf        nomer,F
symb_1        incf        nomer,F             
              call        tab_symb
              call        sendispdat
              decfsz      temp,F
              goto        symb_1
              movlw       .0
              call        sendispdat
              return

tab_symb      movlw       high tab1         ;   Lcd 
              movwf       PCLATH            ;
              movf        nomer,W           ;
              addlw       low tab1          ;
              btfsc       STATUS,C          ;
              incf        PCLATH,F          ;
              movf        nomer,W           ;
              addwf       PCL,F  
                                                  
tab1          dt 0x3E, 0x51, 0x49, 0x45, 0x3E;       ; 0      (48)
              dt 0x00, 0x42, 0x7F, 0x40, 0x00;       ; 1 
              dt 0x42, 0x61, 0x51, 0x49, 0x46;       ; 2 
              dt 0x21, 0x41, 0x45, 0x4B, 0x31;       ; 3 
              dt 0x18, 0x14, 0x12, 0x7F, 0x10;       ; 4 
              dt 0x27, 0x45, 0x45, 0x45, 0x39;       ; 5 
              dt 0x3C, 0x4A, 0x49, 0x49, 0x30;       ; 6 
              dt 0x01, 0x71, 0x09, 0x05, 0x03;       ; 7 
              dt 0x36, 0x49, 0x49, 0x49, 0x36;       ; 8 
              dt 0x06, 0x49, 0x49, 0x29, 0x1E;       ; 9      (57)

              dt 0x00, 0x00, 0x00, 0x00, 0x00;       ;(space) (32)
              dt 0x08, 0x08, 0x08, 0x08, 0x08;       ; -      (45)
              dt 0x00, 0x60, 0x60, 0x00, 0x00;       ; .      (46)
              dt 0x20, 0x10, 0x08, 0x04, 0x02;       ; /      (47) 
              dt 0x00, 0x36, 0x36, 0x00, 0x00;       ; :      (58)       
              dt 0x7E, 0x11, 0x11, 0x11, 0x7E;       ; A      (65)
              dt 0x7F, 0x49, 0x49, 0x49, 0x41;       ; E      (69)
              dt 0x7F, 0x08, 0x14, 0x22, 0x41;       ; K      (75)
              dt 0x7F, 0x02, 0x04, 0x02, 0x7F;       ; M      (77)
              dt 0x7F, 0x04, 0x08, 0x10, 0x7F;       ; N      (78)
              dt 0x46, 0x49, 0x49, 0x49, 0x31;       ; S      (83)
              dt 0x1F, 0x20, 0x40, 0x20, 0x1F;       ; V      (86)
              dt 0x7F, 0x20, 0x18, 0x20, 0x7F;       ; W      (87)



kod_ascii     movlw       .255              ; ascii 
              movwf       tmp_symb
kod_1         incf        tmp_symb,F
              call        tab_ascii
              xorwf       nomer,W
              btfss       STATUS,Z
              goto        kod_1
              movlw       .10
              addwf       tmp_symb,W
              movwf       nomer
              return
              
tab_ascii     movlw       high tab2         ;
              movwf       PCLATH            ;
              movf        tmp_symb,W        ;
              addlw       low tab2          ;
              btfsc       STATUS,C          ;
              incf        PCLATH,F          ;
              movf        tmp_symb,W        ;
              addwf       PCL,F  
                                                  
tab2          dt ' ', '-', '.', '/', ':', 'A';      
              dt 'E', 'K', 'M', 'N', 'S', 'V', 'W';

              end                         ;  